<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: util/mesh2dual.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_81f17f03227d7067ce13f3651b0bf66b.html">util</a>
  </div>
</div>
<div class="contents">
<h1>mesh2dual.c</h1><a href="mesh2dual_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: mesh2dual.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef METIS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>EXTERN_C_BEGIN
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;metis.h&quot;</span>
<a name="l00032"></a>00032 EXTERN_C_END
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="comment">/* for size of connectivity matrix generated by METIS_MeshToNodal */</span>
<a name="l00036"></a>00036 <span class="preprocessor">#define JASIZE 25</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span>
<a name="l00040"></a><a class="code" href="util_8h.html#a194ba29523e593289f63c3071c31a34b">00040</a> <span class="keywordtype">int</span> <a class="code" href="mesh2dual_8c.html#a194ba29523e593289f63c3071c31a34b">Mesh2VertEle</a>(<span class="keywordtype">int</span> n_ele, <span class="keywordtype">int</span> n_vert, <span class="keywordtype">int</span> *elevert, <span class="keywordtype">int</span> **ia, <span class="keywordtype">int</span> **ja)
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   <span class="comment">/* This function calculates the vertex-element connectivity.</span>
<a name="l00045"></a>00045 <span class="comment">   * For each vertex all elements, which share this vertex are stored.</span>
<a name="l00046"></a>00046 <span class="comment">   *</span>
<a name="l00047"></a>00047 <span class="comment">   * This is different from METIS&#39;s MeshToNodal, which calculates</span>
<a name="l00048"></a>00048 <span class="comment">   * the connectivity between nodes (i.e. it connects two vertices [nodes] in</span>
<a name="l00049"></a>00049 <span class="comment">   * the graph if they are connected by an edge in the mesh).</span>
<a name="l00050"></a>00050 <span class="comment">   */</span>
<a name="l00051"></a>00051 
<a name="l00052"></a>00052   <span class="keywordtype">int</span> *tca;
<a name="l00053"></a>00053   ierr = PetscMalloc(n_vert*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;tca);CHKERRQ(ierr);
<a name="l00054"></a>00054   ierr = PetscMemzero(tca,n_vert*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));CHKERRQ(ierr);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="comment">/* count number of elements sharing each node */</span>
<a name="l00057"></a>00057   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_ele;i++) {
<a name="l00058"></a>00058     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;j++) {
<a name="l00059"></a>00059       tca[elevert[NV*i+j]]++;
<a name="l00060"></a>00060     }
<a name="l00061"></a>00061   }
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <span class="comment">/* create index array */</span>
<a name="l00064"></a>00064   <span class="keywordtype">int</span> *tia;
<a name="l00065"></a>00065   ierr = PetscMalloc((n_vert+1)*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;tia);CHKERRQ(ierr);
<a name="l00066"></a>00066   tia[0]=0;
<a name="l00067"></a>00067   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=1;i&lt;n_vert+1;i++) {
<a name="l00068"></a>00068     tia[i]=tia[i-1]+tca[i-1];
<a name="l00069"></a>00069   }
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00072"></a>00072     <span class="stringliteral">&quot;Allocating %i MB for %i elements in adjacency matrix\n&quot;</span>,
<a name="l00073"></a>00073     tia[n_vert]*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>)/1024/1024+1,
<a name="l00074"></a>00074     tia[n_vert]
<a name="l00075"></a>00075   );
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   <span class="keywordtype">int</span> *tja;
<a name="l00078"></a>00078   ierr = PetscMalloc(tia[n_vert]*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;tja);CHKERRQ(ierr);
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   ierr = PetscMemzero(tca,n_vert*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));CHKERRQ(ierr);
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <span class="comment">/* find all elements, which share a node */</span>
<a name="l00083"></a>00083   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_ele;i++) {
<a name="l00084"></a>00084     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;j++) {
<a name="l00085"></a>00085       <span class="keywordtype">int</span> v;
<a name="l00086"></a>00086       v=elevert[NV*i+j];
<a name="l00087"></a>00087       tja[tia[v]+tca[v]]=i;
<a name="l00088"></a>00088       tca[v]++;
<a name="l00089"></a>00089     }
<a name="l00090"></a>00090   }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="comment">/* count total number of connectivities */</span>
<a name="l00093"></a>00093   <span class="keywordtype">int</span> cnt=0;
<a name="l00094"></a>00094   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_vert;i++) {
<a name="l00095"></a>00095     cnt+=tca[i];
<a name="l00096"></a>00096     assert(tca[i]==tia[i+1]-tia[i]);
<a name="l00097"></a>00097   }
<a name="l00098"></a>00098   assert(cnt==tia[n_vert]);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span>  PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Dual mesh:\n&quot;</span>);
<a name="l00102"></a>00102   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;   node  |   #  | elements; ia\n&quot;</span>);
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="keywordtype">int</span> cnt2=0;
<a name="l00105"></a>00105   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_vert;i++) {
<a name="l00106"></a>00106     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%7i %6i &quot;</span>,i,tia[i+1]-tia[i]);
<a name="l00107"></a>00107     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=tia[i];j&lt;tia[i+1];j++) {
<a name="l00108"></a>00108       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%7i &quot;</span>,tja[j]);
<a name="l00109"></a>00109       cnt2++;
<a name="l00110"></a>00110     }
<a name="l00111"></a>00111     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%6i\n&quot;</span>,tia[i]);
<a name="l00112"></a>00112   }
<a name="l00113"></a>00113   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%7i %6i %6i\n&quot;</span>,n_vert,0,tia[n_vert]);
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   assert(cnt==cnt2);
<a name="l00116"></a>00116 <span class="preprocessor">#endif</span>
<a name="l00117"></a>00117 <span class="preprocessor"></span>
<a name="l00118"></a>00118   ierr = PetscFree(tca);CHKERRQ(ierr);
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   *ia=tia;
<a name="l00121"></a>00121   *ja=tja;
<a name="l00122"></a>00122 
<a name="l00123"></a>00123   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00124"></a>00124 }
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a><a class="code" href="util_8h.html#abb99aec57817a85ad1c4c2552f695434">00127</a> <span class="keywordtype">int</span> <a class="code" href="mesh2dual_8c.html#abb99aec57817a85ad1c4c2552f695434">Mesh2Nodal</a>(<span class="keywordtype">int</span> n_ele, <span class="keywordtype">int</span> n_vert, <span class="keywordtype">int</span> *elevert, <span class="keywordtype">int</span> **ia, <span class="keywordtype">int</span> **ja)
<a name="l00128"></a>00128 {
<a name="l00129"></a>00129   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   <span class="comment">/* This function calculates the vertex-vertex connectivity.</span>
<a name="l00132"></a>00132 <span class="comment">   * For each vertex all vertices, which are connected by an edge, are stored.</span>
<a name="l00133"></a>00133 <span class="comment">   *</span>
<a name="l00134"></a>00134 <span class="comment">   * This is (for magpar&#39;s purposes) a full replacement for METIS&#39;s MeshToNodal function.</span>
<a name="l00135"></a>00135 <span class="comment">   */</span>
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   <span class="comment">/* obtain vertex-element connectivity first */</span>
<a name="l00138"></a>00138   <span class="keywordtype">int</span> *veia,*veja;
<a name="l00139"></a>00139   ierr = <a class="code" href="mesh2dual_8c.html#a194ba29523e593289f63c3071c31a34b">Mesh2VertEle</a>(n_ele,n_vert,elevert,&amp;veia,&amp;veja);CHKERRQ(ierr);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   <span class="comment">/* allocate memory for counters */</span>
<a name="l00142"></a>00142   <span class="keywordtype">int</span> *tca;
<a name="l00143"></a>00143   ierr = PetscMalloc(n_vert*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;tca);CHKERRQ(ierr);
<a name="l00144"></a>00144   ierr = PetscMemzero(tca,n_vert*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));CHKERRQ(ierr);
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   <span class="comment">/* allocate temp. memory for neighbors */</span>
<a name="l00147"></a>00147 <span class="preprocessor">#define MAXVERTVERT 10000</span>
<a name="l00148"></a>00148 <span class="preprocessor"></span>  <span class="keywordtype">int</span> *tj;
<a name="l00149"></a>00149   ierr = PetscMalloc(<a class="code" href="mesh2dual_8c.html#a51ea3c9c2c0666b30c9e1253d1e21306">MAXVERTVERT</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;tj);CHKERRQ(ierr);
<a name="l00150"></a>00150 
<a name="l00151"></a>00151   <span class="comment">/* count number of neighboring vertices */</span>
<a name="l00152"></a>00152   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> v=0;v&lt;n_vert;v++) {
<a name="l00153"></a>00153     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="mesh2dual_8c.html#a51ea3c9c2c0666b30c9e1253d1e21306">MAXVERTVERT</a>;i++) {
<a name="l00154"></a>00154       tj[i]=-1;
<a name="l00155"></a>00155     }
<a name="l00156"></a>00156     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=veia[v];i&lt;veia[v+1];i++) {
<a name="l00157"></a>00157       <span class="keywordtype">int</span> el;
<a name="l00158"></a>00158       el=veja[i];
<a name="l00159"></a>00159       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;j++) {
<a name="l00160"></a>00160         <span class="keywordtype">int</span> vel;
<a name="l00161"></a>00161         vel=elevert[NV*el+j];
<a name="l00162"></a>00162 
<a name="l00163"></a>00163         <span class="comment">/* skip self */</span>
<a name="l00164"></a>00164         <span class="keywordflow">if</span> (vel==v) <span class="keywordflow">continue</span>;
<a name="l00165"></a>00165 
<a name="l00166"></a>00166         <span class="keywordtype">int</span> found;
<a name="l00167"></a>00167         found=0;
<a name="l00168"></a>00168         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0;k&lt;tca[v];k++) {
<a name="l00169"></a>00169           <span class="keywordflow">if</span> (vel==tj[k]) {
<a name="l00170"></a>00170             found=1;
<a name="l00171"></a>00171             <span class="keywordflow">break</span>;
<a name="l00172"></a>00172           }
<a name="l00173"></a>00173         }
<a name="l00174"></a>00174         <span class="keywordflow">if</span> (!found) {
<a name="l00175"></a>00175           <span class="comment">/* add new vertex */</span>
<a name="l00176"></a>00176           tj[tca[v]]=vel;
<a name="l00177"></a>00177           tca[v]++;
<a name="l00178"></a>00178           <span class="comment">/* check for array overrun */</span>
<a name="l00179"></a>00179           assert(tca[v]&lt;MAXVERTVERT);
<a name="l00180"></a>00180         }
<a name="l00181"></a>00181       }
<a name="l00182"></a>00182     }
<a name="l00183"></a>00183   }
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   ierr = PetscFree(tj);CHKERRQ(ierr);
<a name="l00186"></a>00186 
<a name="l00187"></a>00187   <span class="comment">/* create index array */</span>
<a name="l00188"></a>00188   <span class="keywordtype">int</span> *tia;
<a name="l00189"></a>00189   ierr = PetscMalloc((n_vert+1)*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;tia);CHKERRQ(ierr);
<a name="l00190"></a>00190   tia[0]=0;
<a name="l00191"></a>00191   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=1;i&lt;n_vert+1;i++) {
<a name="l00192"></a>00192     tia[i]=tia[i-1]+tca[i-1];
<a name="l00193"></a>00193   }
<a name="l00194"></a>00194 
<a name="l00195"></a>00195   <span class="comment">/* reset counter array */</span>
<a name="l00196"></a>00196   ierr = PetscMemzero(tca,n_vert*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));CHKERRQ(ierr);
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00199"></a>00199     <span class="stringliteral">&quot;Allocating %i MB for %i elements in adjacency matrix\n&quot;</span>,
<a name="l00200"></a>00200     tia[n_vert]*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>)/1024/1024+1,
<a name="l00201"></a>00201     tia[n_vert]
<a name="l00202"></a>00202   );
<a name="l00203"></a>00203 
<a name="l00204"></a>00204   <span class="keywordtype">int</span> *tja;
<a name="l00205"></a>00205   ierr = PetscMalloc(tia[n_vert]*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;tja);CHKERRQ(ierr);
<a name="l00206"></a>00206   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;tia[n_vert];i++) {
<a name="l00207"></a>00207     tja[i]=-1;
<a name="l00208"></a>00208   }
<a name="l00209"></a>00209 
<a name="l00210"></a>00210   <span class="comment">/* find all neighboring vertices */</span>
<a name="l00211"></a>00211   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> v=0;v&lt;n_vert;v++) {
<a name="l00212"></a>00212     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=veia[v];i&lt;veia[v+1];i++) {
<a name="l00213"></a>00213       <span class="keywordtype">int</span> el;
<a name="l00214"></a>00214       el=veja[i];
<a name="l00215"></a>00215       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;j++) {
<a name="l00216"></a>00216         <span class="keywordtype">int</span> vel;
<a name="l00217"></a>00217         vel=elevert[NV*el+j];
<a name="l00218"></a>00218 
<a name="l00219"></a>00219         <span class="comment">/* skip self */</span>
<a name="l00220"></a>00220         <span class="keywordflow">if</span> (vel==v) <span class="keywordflow">continue</span>;
<a name="l00221"></a>00221 
<a name="l00222"></a>00222         <span class="keywordtype">int</span> found;
<a name="l00223"></a>00223         found=0;
<a name="l00224"></a>00224         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=tia[v];k&lt;tia[v+1];k++) {
<a name="l00225"></a>00225           <span class="keywordflow">if</span> (vel==tja[k]) {
<a name="l00226"></a>00226             found=1;
<a name="l00227"></a>00227             <span class="keywordflow">break</span>;
<a name="l00228"></a>00228           }
<a name="l00229"></a>00229         }
<a name="l00230"></a>00230         <span class="keywordflow">if</span> (!found) {
<a name="l00231"></a>00231           <span class="comment">/* add new vertex */</span>
<a name="l00232"></a>00232           tja[tia[v]+tca[v]]=vel;
<a name="l00233"></a>00233           tca[v]++;
<a name="l00234"></a>00234           <span class="comment">/* check for array overrun */</span>
<a name="l00235"></a>00235           assert(tca[v]&lt;=tia[v+1]-tia[v]);
<a name="l00236"></a>00236         }
<a name="l00237"></a>00237       }
<a name="l00238"></a>00238     }
<a name="l00239"></a>00239     assert(tca[v]==tia[v+1]-tia[v]);
<a name="l00240"></a>00240   }
<a name="l00241"></a>00241 
<a name="l00242"></a>00242   <span class="comment">/* count total number of connectivities */</span>
<a name="l00243"></a>00243   <span class="keywordtype">int</span> cnt=0;
<a name="l00244"></a>00244   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_vert;i++) {
<a name="l00245"></a>00245     cnt+=tca[i];
<a name="l00246"></a>00246     assert(tca[i]==tia[i+1]-tia[i]);
<a name="l00247"></a>00247   }
<a name="l00248"></a>00248   assert(cnt==tia[n_vert]);
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00251"></a>00251 <span class="preprocessor"></span>  PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Nodal mesh:\n&quot;</span>);
<a name="l00252"></a>00252   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;   node  |   #  | nodes; ia\n&quot;</span>);
<a name="l00253"></a>00253 
<a name="l00254"></a>00254   <span class="keywordtype">int</span> cnt2=0;
<a name="l00255"></a>00255   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_vert;i++) {
<a name="l00256"></a>00256     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%7i %6i &quot;</span>,i,tia[i+1]-tia[i]);
<a name="l00257"></a>00257     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=tia[i];j&lt;tia[i+1];j++) {
<a name="l00258"></a>00258       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%7i &quot;</span>,tja[j]);
<a name="l00259"></a>00259       cnt2++;
<a name="l00260"></a>00260     }
<a name="l00261"></a>00261     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%6i\n&quot;</span>,tia[i]);
<a name="l00262"></a>00262   }
<a name="l00263"></a>00263   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%7i %6i %6i\n&quot;</span>,n_vert,0,tia[n_vert]);
<a name="l00264"></a>00264 
<a name="l00265"></a>00265   assert(cnt==cnt2);
<a name="l00266"></a>00266 <span class="preprocessor">#endif</span>
<a name="l00267"></a>00267 <span class="preprocessor"></span>
<a name="l00268"></a>00268   ierr = PetscFree(tca);CHKERRQ(ierr);
<a name="l00269"></a>00269   ierr = PetscFree(veia);CHKERRQ(ierr);
<a name="l00270"></a>00270   ierr = PetscFree(veja);CHKERRQ(ierr);
<a name="l00271"></a>00271 
<a name="l00272"></a>00272   *ia=tia;
<a name="l00273"></a>00273   *ja=tja;
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 <span class="preprocessor">#ifdef METIS</span>
<a name="l00276"></a>00276 <span class="preprocessor"></span><span class="preprocessor">#ifdef DEBUG</span>
<a name="l00277"></a>00277 <span class="preprocessor"></span>  <span class="comment">/* compare with Metis&#39;s METIS_MeshToNodal function */</span>
<a name="l00278"></a>00278   idxtype *mia,*mja;
<a name="l00279"></a>00279   ierr = PetscMalloc((n_vert+1)*<span class="keyword">sizeof</span>(idxtype),&amp;mia);CHKERRQ(ierr);
<a name="l00280"></a>00280   ierr = PetscMalloc(JASIZE*n_vert*<span class="keyword">sizeof</span>(idxtype),&amp;mja);CHKERRQ(ierr);
<a name="l00281"></a>00281   <span class="keywordtype">int</span>  zero=0,two=2;
<a name="l00282"></a>00282   METIS_MeshToNodal(
<a name="l00283"></a>00283     &amp;n_ele,
<a name="l00284"></a>00284     &amp;n_vert,
<a name="l00285"></a>00285     elevert,
<a name="l00286"></a>00286     &amp;two,
<a name="l00287"></a>00287     &amp;zero,
<a name="l00288"></a>00288     mia,
<a name="l00289"></a>00289     mja
<a name="l00290"></a>00290   );
<a name="l00291"></a>00291   <span class="comment">/* check for array overrun */</span>
<a name="l00292"></a>00292   assert(mia[n_vert]&lt;JASIZE*n_vert);
<a name="l00293"></a>00293 
<a name="l00294"></a>00294   <span class="keywordflow">if</span> (tia[n_vert]!=mia[n_vert]) {
<a name="l00295"></a>00295     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;ERROR1: %i %i %i %i %i\n&quot;</span>,n_vert,tia[n_vert],mia[n_vert]);
<a name="l00296"></a>00296     SETERRQ(PETSC_ERR_LIB,<span class="stringliteral">&quot;Inconsistency with METIS detected! Exiting!\n&quot;</span>);
<a name="l00297"></a>00297   }
<a name="l00298"></a>00298   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> v=0;v&lt;n_vert+1;v++) {
<a name="l00299"></a>00299     <span class="keywordflow">if</span> (tia[v]!=mia[v]) {
<a name="l00300"></a>00300       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;ERROR2: %i %i %i\n&quot;</span>,v,tia[v],mia[v]);
<a name="l00301"></a>00301       SETERRQ(PETSC_ERR_LIB,<span class="stringliteral">&quot;Inconsistency with METIS detected! Exiting!\n&quot;</span>);
<a name="l00302"></a>00302     }
<a name="l00303"></a>00303     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=tia[v];i&lt;tia[n_vert];i++) {
<a name="l00304"></a>00304       <span class="keywordflow">if</span> (tja[i]!=mja[i]) {
<a name="l00305"></a>00305         PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;ERROR3: %i %i %i %i %i\n&quot;</span>,v,tia[v],mia[v],tja[i],mja[i]);
<a name="l00306"></a>00306         SETERRQ(PETSC_ERR_LIB,<span class="stringliteral">&quot;Inconsistency with METIS detected! Exiting!\n&quot;</span>);
<a name="l00307"></a>00307       }
<a name="l00308"></a>00308     }
<a name="l00309"></a>00309   }
<a name="l00310"></a>00310 
<a name="l00311"></a>00311   ierr = PetscFree(mia);CHKERRQ(ierr);
<a name="l00312"></a>00312   ierr = PetscFree(mja);CHKERRQ(ierr);
<a name="l00313"></a>00313 <span class="preprocessor">#endif</span>
<a name="l00314"></a>00314 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00315"></a>00315 <span class="preprocessor"></span>
<a name="l00316"></a>00316   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00317"></a>00317 }
<a name="l00318"></a>00318 
<a name="l00319"></a>00319 
<a name="l00320"></a><a class="code" href="util_8h.html#a072403ed5e4bbd16fd845d52009d1270">00320</a> <span class="keywordtype">int</span> <a class="code" href="mesh2dual_8c.html#a072403ed5e4bbd16fd845d52009d1270">Mesh2Dual</a>(<span class="keywordtype">int</span> n_ele, <span class="keywordtype">int</span> n_vert, <span class="keywordtype">int</span> *elevert, <span class="keywordtype">int</span> **ia, <span class="keywordtype">int</span> **ja)
<a name="l00321"></a>00321 {
<a name="l00322"></a>00322   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00323"></a>00323 
<a name="l00324"></a>00324   <span class="comment">/* This function calculates the element-element connectivity.</span>
<a name="l00325"></a>00325 <span class="comment">   * For each element all elements, which share a face, are stored.</span>
<a name="l00326"></a>00326 <span class="comment">   *</span>
<a name="l00327"></a>00327 <span class="comment">   * This is (for magpar&#39;s purposes) a full replacement for METIS&#39;s MeshToDual function.</span>
<a name="l00328"></a>00328 <span class="comment">   */</span>
<a name="l00329"></a>00329 
<a name="l00330"></a>00330   <span class="comment">/* obtain vertex-element connectivity first */</span>
<a name="l00331"></a>00331   <span class="keywordtype">int</span> *veia,*veja;
<a name="l00332"></a>00332   ierr = <a class="code" href="mesh2dual_8c.html#a194ba29523e593289f63c3071c31a34b">Mesh2VertEle</a>(n_ele,n_vert,elevert,&amp;veia,&amp;veja);CHKERRQ(ierr);
<a name="l00333"></a>00333 
<a name="l00334"></a>00334   <span class="comment">/* allocate memory for counters */</span>
<a name="l00335"></a>00335   <span class="keywordtype">int</span> *tca;
<a name="l00336"></a>00336   ierr = PetscMalloc(n_ele*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;tca);CHKERRQ(ierr);
<a name="l00337"></a>00337   ierr = PetscMemzero(tca,n_ele*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));CHKERRQ(ierr);
<a name="l00338"></a>00338 
<a name="l00339"></a>00339   <span class="comment">/* allocate temp. memory for neighbors */</span>
<a name="l00340"></a>00340 <span class="preprocessor">#define MAXELEELE NF</span>
<a name="l00341"></a>00341 <span class="preprocessor"></span>  <span class="keywordtype">int</span> *tj;
<a name="l00342"></a>00342   ierr = PetscMalloc(<a class="code" href="mesh2dual_8c.html#a9f95d406391938710a421eb1fecf49c1">MAXELEELE</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;tj);CHKERRQ(ierr);
<a name="l00343"></a>00343 
<a name="l00344"></a>00344   <span class="comment">/* count number of neighboring elements */</span>
<a name="l00345"></a>00345   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> el=0;el&lt;n_ele;el++) {
<a name="l00346"></a>00346     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="mesh2dual_8c.html#a9f95d406391938710a421eb1fecf49c1">MAXELEELE</a>;i++) {
<a name="l00347"></a>00347       tj[i]=-1;
<a name="l00348"></a>00348     }
<a name="l00349"></a>00349     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;j++) {
<a name="l00350"></a>00350       <span class="keywordflow">if</span> (tca[el]==<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>) <span class="keywordflow">break</span>;
<a name="l00351"></a>00351       <span class="keywordtype">int</span> v;
<a name="l00352"></a>00352       v=elevert[NV*el+j];
<a name="l00353"></a>00353       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=veia[v];i&lt;veia[v+1];i++) {
<a name="l00354"></a>00354         <span class="keywordflow">if</span> (tca[el]==<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>) <span class="keywordflow">break</span>;
<a name="l00355"></a>00355         <span class="keywordflow">if</span> (j==0 &amp;&amp; tca[el]==<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>-1) <span class="keywordflow">break</span>;
<a name="l00356"></a>00356         <span class="keywordtype">int</span> nel;
<a name="l00357"></a>00357         nel=veja[i];
<a name="l00358"></a>00358         <span class="keywordflow">if</span> (nel==el) <span class="keywordflow">continue</span>;
<a name="l00359"></a>00359         <span class="keywordtype">int</span> x;
<a name="l00360"></a>00360         x=<a class="code" href="tettri_8c.html#aa5edf1170e954574fb88dff3cafac7c1">tetnb</a>(elevert+NV*el,elevert+NV*nel,PETSC_NULL);
<a name="l00361"></a>00361         assert(x&lt;NV);
<a name="l00362"></a>00362         <span class="keywordflow">if</span> (x&lt;3) <span class="keywordflow">continue</span>;
<a name="l00363"></a>00363 
<a name="l00364"></a>00364         <span class="keywordtype">int</span> found;
<a name="l00365"></a>00365         found=0;
<a name="l00366"></a>00366 
<a name="l00367"></a>00367         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0;k&lt;tca[el];k++) {
<a name="l00368"></a>00368           <span class="keywordflow">if</span> (nel==tj[k]) {
<a name="l00369"></a>00369             found=1;
<a name="l00370"></a>00370             <span class="keywordflow">break</span>;
<a name="l00371"></a>00371           }
<a name="l00372"></a>00372         }
<a name="l00373"></a>00373         <span class="keywordflow">if</span> (!found) {
<a name="l00374"></a>00374           <span class="comment">/* add new neighbor */</span>
<a name="l00375"></a>00375           tj[tca[el]]=nel;
<a name="l00376"></a>00376           tca[el]++;
<a name="l00377"></a>00377           <span class="comment">/* check for array overrun */</span>
<a name="l00378"></a>00378           assert(tca[el]&lt;=MAXELEELE);
<a name="l00379"></a>00379           <span class="keywordflow">if</span> (tca[el]==<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>) <span class="keywordflow">break</span>;
<a name="l00380"></a>00380         }
<a name="l00381"></a>00381       }
<a name="l00382"></a>00382     }
<a name="l00383"></a>00383   }
<a name="l00384"></a>00384 
<a name="l00385"></a>00385   ierr = PetscFree(tj);CHKERRQ(ierr);
<a name="l00386"></a>00386 
<a name="l00387"></a>00387   <span class="comment">/* create index array */</span>
<a name="l00388"></a>00388   <span class="keywordtype">int</span> *tia;
<a name="l00389"></a>00389   ierr = PetscMalloc((n_ele+1)*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;tia);CHKERRQ(ierr);
<a name="l00390"></a>00390   tia[0]=0;
<a name="l00391"></a>00391   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=1;i&lt;n_ele+1;i++) {
<a name="l00392"></a>00392     tia[i]=tia[i-1]+tca[i-1];
<a name="l00393"></a>00393   }
<a name="l00394"></a>00394 
<a name="l00395"></a>00395   <span class="comment">/* reset counter array */</span>
<a name="l00396"></a>00396   ierr = PetscMemzero(tca,n_ele*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));CHKERRQ(ierr);
<a name="l00397"></a>00397 
<a name="l00398"></a>00398   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00399"></a>00399     <span class="stringliteral">&quot;Allocating %i MB for %i elements in adjacency matrix\n&quot;</span>,
<a name="l00400"></a>00400     tia[n_ele]*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>)/1024/1024+1,
<a name="l00401"></a>00401     tia[n_ele]
<a name="l00402"></a>00402   );
<a name="l00403"></a>00403 
<a name="l00404"></a>00404   <span class="keywordtype">int</span> *tja;
<a name="l00405"></a>00405   ierr = PetscMalloc(tia[n_ele]*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;tja);CHKERRQ(ierr);
<a name="l00406"></a>00406   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;tia[n_ele];i++) {
<a name="l00407"></a>00407     tja[i]=-1;
<a name="l00408"></a>00408   }
<a name="l00409"></a>00409 
<a name="l00410"></a>00410   <span class="comment">/* store all neighboring elements */</span>
<a name="l00411"></a>00411   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> el=0;el&lt;n_ele;el++) {
<a name="l00412"></a>00412     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;j++) {
<a name="l00413"></a>00413       <span class="keywordflow">if</span> (tca[el]==<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>) <span class="keywordflow">break</span>;
<a name="l00414"></a>00414       <span class="keywordtype">int</span> v;
<a name="l00415"></a>00415       v=elevert[NV*el+j];
<a name="l00416"></a>00416       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=veia[v];i&lt;veia[v+1];i++) {
<a name="l00417"></a>00417         <span class="keywordflow">if</span> (j==0 &amp;&amp; tca[el]==<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>-1) <span class="keywordflow">break</span>;
<a name="l00418"></a>00418         <span class="keywordflow">if</span> (tca[el]==<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>) <span class="keywordflow">break</span>;
<a name="l00419"></a>00419         <span class="keywordtype">int</span> nel;
<a name="l00420"></a>00420         nel=veja[i];
<a name="l00421"></a>00421         <span class="keywordflow">if</span> (nel==el) <span class="keywordflow">continue</span>;
<a name="l00422"></a>00422         <span class="keywordtype">int</span> x;
<a name="l00423"></a>00423         x=<a class="code" href="tettri_8c.html#aa5edf1170e954574fb88dff3cafac7c1">tetnb</a>(elevert+NV*el,elevert+NV*nel,PETSC_NULL);
<a name="l00424"></a>00424         assert(x&lt;NV);
<a name="l00425"></a>00425         <span class="keywordflow">if</span> (x&lt;3) <span class="keywordflow">continue</span>;
<a name="l00426"></a>00426 
<a name="l00427"></a>00427         <span class="keywordtype">int</span> found;
<a name="l00428"></a>00428         found=0;
<a name="l00429"></a>00429 
<a name="l00430"></a>00430         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0;k&lt;tca[el];k++) {
<a name="l00431"></a>00431           <span class="keywordflow">if</span> (nel==tja[tia[el]+k]) {
<a name="l00432"></a>00432             found=1;
<a name="l00433"></a>00433             <span class="keywordflow">break</span>;
<a name="l00434"></a>00434           }
<a name="l00435"></a>00435         }
<a name="l00436"></a>00436         <span class="keywordflow">if</span> (!found) {
<a name="l00437"></a>00437           <span class="comment">/* add new neighbor */</span>
<a name="l00438"></a>00438           tja[tia[el]+tca[el]]=nel;
<a name="l00439"></a>00439           tca[el]++;
<a name="l00440"></a>00440           <span class="comment">/* check for array overrun */</span>
<a name="l00441"></a>00441           assert(tca[el]&lt;=<a class="code" href="mesh2dual_8c.html#a9f95d406391938710a421eb1fecf49c1">MAXELEELE</a>);
<a name="l00442"></a>00442           <span class="keywordflow">if</span> (tca[el]==<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>) <span class="keywordflow">break</span>;
<a name="l00443"></a>00443         }
<a name="l00444"></a>00444       }
<a name="l00445"></a>00445     }
<a name="l00446"></a>00446     assert(tca[el]==tia[el+1]-tia[el]);
<a name="l00447"></a>00447   }
<a name="l00448"></a>00448 
<a name="l00449"></a>00449   <span class="comment">/* count total number of connectivities */</span>
<a name="l00450"></a>00450   <span class="keywordtype">int</span> cnt=0;
<a name="l00451"></a>00451   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_ele;i++) {
<a name="l00452"></a>00452     cnt+=tca[i];
<a name="l00453"></a>00453     assert(tca[i]==tia[i+1]-tia[i]);
<a name="l00454"></a>00454   }
<a name="l00455"></a>00455   assert(cnt==tia[n_ele]);
<a name="l00456"></a>00456 
<a name="l00457"></a>00457 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00458"></a>00458 <span class="preprocessor"></span>  PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Element connectivity:\n&quot;</span>);
<a name="l00459"></a>00459   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;   element  |   #  | neighbors; ia\n&quot;</span>);
<a name="l00460"></a>00460 
<a name="l00461"></a>00461   <span class="keywordtype">int</span> cnt2=0;
<a name="l00462"></a>00462   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_ele;i++) {
<a name="l00463"></a>00463     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%7i %6i &quot;</span>,i,tia[i+1]-tia[i]);
<a name="l00464"></a>00464     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=tia[i];j&lt;tia[i+1];j++) {
<a name="l00465"></a>00465       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%7i &quot;</span>,tja[j]);
<a name="l00466"></a>00466       cnt2++;
<a name="l00467"></a>00467     }
<a name="l00468"></a>00468     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%6i\n&quot;</span>,tia[i]);
<a name="l00469"></a>00469   }
<a name="l00470"></a>00470   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%7i %6i %6i\n&quot;</span>,n_ele,0,tia[n_ele]);
<a name="l00471"></a>00471 
<a name="l00472"></a>00472   assert(cnt==cnt2);
<a name="l00473"></a>00473 <span class="preprocessor">#endif</span>
<a name="l00474"></a>00474 <span class="preprocessor"></span>
<a name="l00475"></a>00475   ierr = PetscFree(tca);CHKERRQ(ierr);
<a name="l00476"></a>00476   ierr = PetscFree(veia);CHKERRQ(ierr);
<a name="l00477"></a>00477   ierr = PetscFree(veja);CHKERRQ(ierr);
<a name="l00478"></a>00478 
<a name="l00479"></a>00479   *ia=tia;
<a name="l00480"></a>00480   *ja=tja;
<a name="l00481"></a>00481 
<a name="l00482"></a>00482 <span class="preprocessor">#ifdef METIS</span>
<a name="l00483"></a>00483 <span class="preprocessor"></span><span class="preprocessor">#ifdef DEBUG</span>
<a name="l00484"></a>00484 <span class="preprocessor"></span>  <span class="comment">/* adjacency matrices */</span>
<a name="l00485"></a>00485   idxtype *mia,*mja;
<a name="l00486"></a>00486   ierr = PetscMalloc((n_ele+1)*<span class="keyword">sizeof</span>(idxtype),&amp;mia);CHKERRQ(ierr);
<a name="l00487"></a>00487   ierr = PetscMalloc(JASIZE*n_ele*<span class="keyword">sizeof</span>(idxtype),&amp;mja);CHKERRQ(ierr);
<a name="l00488"></a>00488   <span class="keywordtype">int</span>  zero=0,two=2;
<a name="l00489"></a>00489   METIS_MeshToDual(
<a name="l00490"></a>00490     &amp;n_ele,
<a name="l00491"></a>00491     &amp;n_vert,
<a name="l00492"></a>00492     elevert,
<a name="l00493"></a>00493     &amp;two,
<a name="l00494"></a>00494     &amp;zero,
<a name="l00495"></a>00495     mia,
<a name="l00496"></a>00496     mja
<a name="l00497"></a>00497   );
<a name="l00498"></a>00498   <span class="comment">/* check for array overrun */</span>
<a name="l00499"></a>00499   assert(mia[n_ele]&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*n_ele);
<a name="l00500"></a>00500 
<a name="l00501"></a>00501   <span class="keywordflow">if</span> (tia[n_ele]!=mia[n_ele]) {
<a name="l00502"></a>00502     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;ERROR1: %i %i %i %i %i\n&quot;</span>,n_ele,tia[n_ele],mia[n_ele]);
<a name="l00503"></a>00503     SETERRQ(PETSC_ERR_LIB,<span class="stringliteral">&quot;Inconsitency with METIS detected! Exiting!\n&quot;</span>);
<a name="l00504"></a>00504   }
<a name="l00505"></a>00505   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> v=0;v&lt;n_ele+1;v++) {
<a name="l00506"></a>00506     <span class="keywordflow">if</span> (tia[v]!=mia[v]) {
<a name="l00507"></a>00507       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;ERROR2: %i %i %i\n&quot;</span>,v,tia[v],mia[v]);
<a name="l00508"></a>00508       SETERRQ(PETSC_ERR_LIB,<span class="stringliteral">&quot;Inconsitency with METIS detected! Exiting!\n&quot;</span>);
<a name="l00509"></a>00509     }
<a name="l00510"></a>00510 <span class="comment">/* METIS uses different ordering!</span>
<a name="l00511"></a>00511 <span class="comment">    for (int i=tia[v];i&lt;tia[n_ele];i++) {</span>
<a name="l00512"></a>00512 <span class="comment">      if (tja[i]!=mja[i]) {</span>
<a name="l00513"></a>00513 <span class="comment">        PetscPrintf(PETSC_COMM_WORLD,&quot;ERROR3: %i %i %i %i %i\n&quot;,v,tia[v],mia[v],tja[i],mja[i]);</span>
<a name="l00514"></a>00514 <span class="comment">        SETERRQ(PETSC_ERR_LIB,&quot;Inconsitency with METIS detected! Exiting!\n&quot;);</span>
<a name="l00515"></a>00515 <span class="comment">      }</span>
<a name="l00516"></a>00516 <span class="comment">    }</span>
<a name="l00517"></a>00517 <span class="comment">*/</span>
<a name="l00518"></a>00518   }
<a name="l00519"></a>00519 
<a name="l00520"></a>00520   ierr = PetscFree(mia);CHKERRQ(ierr);
<a name="l00521"></a>00521   ierr = PetscFree(mja);CHKERRQ(ierr);
<a name="l00522"></a>00522 <span class="preprocessor">#endif</span>
<a name="l00523"></a>00523 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00524"></a>00524 <span class="preprocessor"></span>
<a name="l00525"></a>00525 
<a name="l00526"></a>00526   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00527"></a>00527 }
<a name="l00528"></a>00528 
<a name="l00529"></a>00529 
<a name="l00530"></a>00530 
<a name="l00531"></a><a class="code" href="util_8h.html#a6210ae7524754edb5738f9516cb92654">00531</a> <span class="keywordtype">int</span> <a class="code" href="mesh2dual_8c.html#a6210ae7524754edb5738f9516cb92654">Mesh2Dual2</a>(<span class="keywordtype">int</span> n_ele, <span class="keywordtype">int</span> n_vert, <span class="keywordtype">int</span> *elevert, <span class="keywordtype">int</span> **ia, <span class="keywordtype">int</span> **ja)
<a name="l00532"></a>00532 {
<a name="l00533"></a>00533   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00534"></a>00534 
<a name="l00535"></a>00535   <span class="comment">/* This function calculates the element-element connectivity.</span>
<a name="l00536"></a>00536 <span class="comment">   * For each element all elements, which share a node (!), are stored.</span>
<a name="l00537"></a>00537 <span class="comment">   *</span>
<a name="l00538"></a>00538 <span class="comment">   * This is different from Mesh2Dual!!!</span>
<a name="l00539"></a>00539 <span class="comment">   */</span>
<a name="l00540"></a>00540 
<a name="l00541"></a>00541   <span class="comment">/* obtain vertex-element connectivity first */</span>
<a name="l00542"></a>00542   <span class="keywordtype">int</span> *veia,*veja;
<a name="l00543"></a>00543   ierr = <a class="code" href="mesh2dual_8c.html#a194ba29523e593289f63c3071c31a34b">Mesh2VertEle</a>(n_ele,n_vert,elevert,&amp;veia,&amp;veja);CHKERRQ(ierr);
<a name="l00544"></a>00544 
<a name="l00545"></a>00545   <span class="comment">/* allocate memory for counters */</span>
<a name="l00546"></a>00546   <span class="keywordtype">int</span> *tca;
<a name="l00547"></a>00547   ierr = PetscMalloc(n_ele*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;tca);CHKERRQ(ierr);
<a name="l00548"></a>00548   ierr = PetscMemzero(tca,n_ele*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));CHKERRQ(ierr);
<a name="l00549"></a>00549 
<a name="l00550"></a>00550   <span class="comment">/* allocate temp. memory for neighbors */</span>
<a name="l00551"></a>00551 <span class="preprocessor">#define MAXELEELE NF</span>
<a name="l00552"></a>00552 <span class="preprocessor"></span>  <span class="keywordtype">int</span> *tj;
<a name="l00553"></a>00553   ierr = PetscMalloc(<a class="code" href="mesh2dual_8c.html#a9f95d406391938710a421eb1fecf49c1">MAXELEELE</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;tj);CHKERRQ(ierr);
<a name="l00554"></a>00554 
<a name="l00555"></a>00555   <span class="comment">/* count number of neighboring elements */</span>
<a name="l00556"></a>00556   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> el=0;el&lt;n_ele;el++) {
<a name="l00557"></a>00557     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="mesh2dual_8c.html#a9f95d406391938710a421eb1fecf49c1">MAXELEELE</a>;i++) {
<a name="l00558"></a>00558       tj[i]=-1;
<a name="l00559"></a>00559     }
<a name="l00560"></a>00560     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;j++) {
<a name="l00561"></a>00561       <span class="keywordtype">int</span> v;
<a name="l00562"></a>00562       v=elevert[NV*el+j];
<a name="l00563"></a>00563       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=veia[v];i&lt;veia[v+1];i++) {
<a name="l00564"></a>00564         <span class="keywordtype">int</span> nel;
<a name="l00565"></a>00565         nel=veja[i];
<a name="l00566"></a>00566         <span class="keywordflow">if</span> (nel==el) <span class="keywordflow">continue</span>;
<a name="l00567"></a>00567 <span class="preprocessor">#if 0</span>
<a name="l00568"></a>00568 <span class="preprocessor"></span>        <span class="comment">/* not necessary since all neighbors will be counted */</span>
<a name="l00569"></a>00569         <span class="keywordtype">int</span> x;
<a name="l00570"></a>00570         x=<a class="code" href="tettri_8c.html#aa5edf1170e954574fb88dff3cafac7c1">tetnb</a>(elevert+NV*el,elevert+NV*nel,PETSC_NULL);
<a name="l00571"></a>00571         assert(x&lt;NV);
<a name="l00572"></a>00572         <span class="keywordflow">if</span> (x&lt;1) <span class="keywordflow">continue</span>;
<a name="l00573"></a>00573 <span class="preprocessor">#endif</span>
<a name="l00574"></a>00574 <span class="preprocessor"></span>
<a name="l00575"></a>00575         <span class="keywordtype">int</span> found;
<a name="l00576"></a>00576         found=0;
<a name="l00577"></a>00577 
<a name="l00578"></a>00578         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0;k&lt;tca[el];k++) {
<a name="l00579"></a>00579           <span class="keywordflow">if</span> (nel==tj[k]) {
<a name="l00580"></a>00580             found=1;
<a name="l00581"></a>00581             <span class="keywordflow">break</span>;
<a name="l00582"></a>00582           }
<a name="l00583"></a>00583         }
<a name="l00584"></a>00584         <span class="keywordflow">if</span> (!found) {
<a name="l00585"></a>00585           <span class="comment">/* add new neighbor */</span>
<a name="l00586"></a>00586           tj[tca[el]]=nel;
<a name="l00587"></a>00587           tca[el]++;
<a name="l00588"></a>00588           <span class="comment">/* check for array overrun */</span>
<a name="l00589"></a>00589           assert(tca[el]&lt;=MAXELEELE);
<a name="l00590"></a>00590         }
<a name="l00591"></a>00591       }
<a name="l00592"></a>00592     }
<a name="l00593"></a>00593   }
<a name="l00594"></a>00594 
<a name="l00595"></a>00595   ierr = PetscFree(tj);CHKERRQ(ierr);
<a name="l00596"></a>00596 
<a name="l00597"></a>00597   <span class="comment">/* create index array */</span>
<a name="l00598"></a>00598   <span class="keywordtype">int</span> *tia;
<a name="l00599"></a>00599   ierr = PetscMalloc((n_ele+1)*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;tia);CHKERRQ(ierr);
<a name="l00600"></a>00600   tia[0]=0;
<a name="l00601"></a>00601   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=1;i&lt;n_ele+1;i++) {
<a name="l00602"></a>00602     tia[i]=tia[i-1]+tca[i-1];
<a name="l00603"></a>00603   }
<a name="l00604"></a>00604 
<a name="l00605"></a>00605   <span class="comment">/* reset counter array */</span>
<a name="l00606"></a>00606   ierr = PetscMemzero(tca,n_ele*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));CHKERRQ(ierr);
<a name="l00607"></a>00607 
<a name="l00608"></a>00608   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00609"></a>00609     <span class="stringliteral">&quot;Allocating %i MB for %i elements in adjacency matrix\n&quot;</span>,
<a name="l00610"></a>00610     tia[n_ele]*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>)/1024/1024+1,
<a name="l00611"></a>00611     tia[n_ele]
<a name="l00612"></a>00612   );
<a name="l00613"></a>00613 
<a name="l00614"></a>00614   <span class="keywordtype">int</span> *tja;
<a name="l00615"></a>00615   ierr = PetscMalloc(tia[n_ele]*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;tja);CHKERRQ(ierr);
<a name="l00616"></a>00616   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;tia[n_ele];i++) {
<a name="l00617"></a>00617     tja[i]=-1;
<a name="l00618"></a>00618   }
<a name="l00619"></a>00619 
<a name="l00620"></a>00620   <span class="comment">/* store all neighboring elements */</span>
<a name="l00621"></a>00621   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> el=0;el&lt;n_ele;el++) {
<a name="l00622"></a>00622     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;j++) {
<a name="l00623"></a>00623       <span class="keywordtype">int</span> v;
<a name="l00624"></a>00624       v=elevert[NV*el+j];
<a name="l00625"></a>00625       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=veia[v];i&lt;veia[v+1];i++) {
<a name="l00626"></a>00626         <span class="keywordtype">int</span> nel;
<a name="l00627"></a>00627         nel=veja[i];
<a name="l00628"></a>00628         <span class="keywordflow">if</span> (nel==el) <span class="keywordflow">continue</span>;
<a name="l00629"></a>00629 <span class="preprocessor">#if 0</span>
<a name="l00630"></a>00630 <span class="preprocessor"></span>        <span class="comment">/* not necessary since all neighbors will be counted */</span>
<a name="l00631"></a>00631         <span class="keywordtype">int</span> x;
<a name="l00632"></a>00632         x=<a class="code" href="tettri_8c.html#aa5edf1170e954574fb88dff3cafac7c1">tetnb</a>(elevert+NV*el,elevert+NV*nel,PETSC_NULL);
<a name="l00633"></a>00633         assert(x&lt;NV);
<a name="l00634"></a>00634         <span class="keywordflow">if</span> (x&lt;1) <span class="keywordflow">continue</span>;
<a name="l00635"></a>00635 <span class="preprocessor">#endif</span>
<a name="l00636"></a>00636 <span class="preprocessor"></span>
<a name="l00637"></a>00637         <span class="keywordtype">int</span> found;
<a name="l00638"></a>00638         found=0;
<a name="l00639"></a>00639 
<a name="l00640"></a>00640         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0;k&lt;tca[el];k++) {
<a name="l00641"></a>00641           <span class="keywordflow">if</span> (nel==tja[tia[el]+k]) {
<a name="l00642"></a>00642             found=1;
<a name="l00643"></a>00643             <span class="keywordflow">break</span>;
<a name="l00644"></a>00644           }
<a name="l00645"></a>00645         }
<a name="l00646"></a>00646         <span class="keywordflow">if</span> (!found) {
<a name="l00647"></a>00647           <span class="comment">/* add new neighbor */</span>
<a name="l00648"></a>00648           tja[tia[el]+tca[el]]=nel;
<a name="l00649"></a>00649           tca[el]++;
<a name="l00650"></a>00650           <span class="comment">/* check for array overrun */</span>
<a name="l00651"></a>00651           assert(tca[el]&lt;=<a class="code" href="mesh2dual_8c.html#a9f95d406391938710a421eb1fecf49c1">MAXELEELE</a>);
<a name="l00652"></a>00652         }
<a name="l00653"></a>00653       }
<a name="l00654"></a>00654     }
<a name="l00655"></a>00655     assert(tca[el]==tia[el+1]-tia[el]);
<a name="l00656"></a>00656   }
<a name="l00657"></a>00657 
<a name="l00658"></a>00658   <span class="comment">/* count total number of connectivities */</span>
<a name="l00659"></a>00659   <span class="keywordtype">int</span> cnt=0;
<a name="l00660"></a>00660   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_ele;i++) {
<a name="l00661"></a>00661     cnt+=tca[i];
<a name="l00662"></a>00662     assert(tca[i]==tia[i+1]-tia[i]);
<a name="l00663"></a>00663   }
<a name="l00664"></a>00664   assert(cnt==tia[n_ele]);
<a name="l00665"></a>00665 
<a name="l00666"></a>00666 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00667"></a>00667 <span class="preprocessor"></span>  PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Element connectivity:\n&quot;</span>);
<a name="l00668"></a>00668   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;   element  |   #  | neighbors; ia\n&quot;</span>);
<a name="l00669"></a>00669 
<a name="l00670"></a>00670   <span class="keywordtype">int</span> cnt2=0;
<a name="l00671"></a>00671   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_ele;i++) {
<a name="l00672"></a>00672     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%7i %6i &quot;</span>,i,tia[i+1]-tia[i]);
<a name="l00673"></a>00673     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=tia[i];j&lt;tia[i+1];j++) {
<a name="l00674"></a>00674       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%7i &quot;</span>,tja[j]);
<a name="l00675"></a>00675       cnt2++;
<a name="l00676"></a>00676     }
<a name="l00677"></a>00677     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%6i\n&quot;</span>,tia[i]);
<a name="l00678"></a>00678   }
<a name="l00679"></a>00679   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%7i %6i %6i\n&quot;</span>,n_ele,0,tia[n_ele]);
<a name="l00680"></a>00680 
<a name="l00681"></a>00681   assert(cnt==cnt2);
<a name="l00682"></a>00682 <span class="preprocessor">#endif</span>
<a name="l00683"></a>00683 <span class="preprocessor"></span>
<a name="l00684"></a>00684   ierr = PetscFree(tca);CHKERRQ(ierr);
<a name="l00685"></a>00685   ierr = PetscFree(veia);CHKERRQ(ierr);
<a name="l00686"></a>00686   ierr = PetscFree(veja);CHKERRQ(ierr);
<a name="l00687"></a>00687 
<a name="l00688"></a>00688   *ia=tia;
<a name="l00689"></a>00689   *ja=tja;
<a name="l00690"></a>00690 
<a name="l00691"></a>00691 <span class="preprocessor">#ifdef METIS</span>
<a name="l00692"></a>00692 <span class="preprocessor"></span><span class="preprocessor">#ifdef DEBUG</span>
<a name="l00693"></a>00693 <span class="preprocessor"></span>  <span class="comment">/* adjacency matrices */</span>
<a name="l00694"></a>00694   idxtype *mia,*mja;
<a name="l00695"></a>00695   ierr = PetscMalloc((n_ele+1)*<span class="keyword">sizeof</span>(idxtype),&amp;mia);CHKERRQ(ierr);
<a name="l00696"></a>00696   ierr = PetscMalloc(JASIZE*n_ele*<span class="keyword">sizeof</span>(idxtype),&amp;mja);CHKERRQ(ierr);
<a name="l00697"></a>00697   <span class="keywordtype">int</span>  zero=0,two=2;
<a name="l00698"></a>00698   METIS_MeshToDual(
<a name="l00699"></a>00699     &amp;n_ele,
<a name="l00700"></a>00700     &amp;n_vert,
<a name="l00701"></a>00701     elevert,
<a name="l00702"></a>00702     &amp;two,
<a name="l00703"></a>00703     &amp;zero,
<a name="l00704"></a>00704     mia,
<a name="l00705"></a>00705     mja
<a name="l00706"></a>00706   );
<a name="l00707"></a>00707   <span class="comment">/* check for array overrun */</span>
<a name="l00708"></a>00708   assert(mia[n_ele]&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*n_ele);
<a name="l00709"></a>00709 
<a name="l00710"></a>00710   <span class="keywordflow">if</span> (tia[n_ele]!=mia[n_ele]) {
<a name="l00711"></a>00711     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;ERROR1: %i %i %i %i %i\n&quot;</span>,n_ele,tia[n_ele],mia[n_ele]);
<a name="l00712"></a>00712     SETERRQ(PETSC_ERR_LIB,<span class="stringliteral">&quot;Inconsitency with METIS detected! Exiting!\n&quot;</span>);
<a name="l00713"></a>00713   }
<a name="l00714"></a>00714   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> v=0;v&lt;n_ele+1;v++) {
<a name="l00715"></a>00715     <span class="keywordflow">if</span> (tia[v]!=mia[v]) {
<a name="l00716"></a>00716       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;ERROR2: %i %i %i\n&quot;</span>,v,tia[v],mia[v]);
<a name="l00717"></a>00717       SETERRQ(PETSC_ERR_LIB,<span class="stringliteral">&quot;Inconsitency with METIS detected! Exiting!\n&quot;</span>);
<a name="l00718"></a>00718     }
<a name="l00719"></a>00719 <span class="comment">/* METIS uses different ordering!</span>
<a name="l00720"></a>00720 <span class="comment">    for (int i=tia[v];i&lt;tia[n_ele];i++) {</span>
<a name="l00721"></a>00721 <span class="comment">      if (tja[i]!=mja[i]) {</span>
<a name="l00722"></a>00722 <span class="comment">        PetscPrintf(PETSC_COMM_WORLD,&quot;ERROR3: %i %i %i %i %i\n&quot;,v,tia[v],mia[v],tja[i],mja[i]);</span>
<a name="l00723"></a>00723 <span class="comment">        SETERRQ(PETSC_ERR_LIB,&quot;Inconsitency with METIS detected! Exiting!\n&quot;);</span>
<a name="l00724"></a>00724 <span class="comment">      }</span>
<a name="l00725"></a>00725 <span class="comment">    }</span>
<a name="l00726"></a>00726 <span class="comment">*/</span>
<a name="l00727"></a>00727   }
<a name="l00728"></a>00728 
<a name="l00729"></a>00729   ierr = PetscFree(mia);CHKERRQ(ierr);
<a name="l00730"></a>00730   ierr = PetscFree(mja);CHKERRQ(ierr);
<a name="l00731"></a>00731 <span class="preprocessor">#endif</span>
<a name="l00732"></a>00732 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00733"></a>00733 <span class="preprocessor"></span>
<a name="l00734"></a>00734 
<a name="l00735"></a>00735   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00736"></a>00736 }
<a name="l00737"></a>00737 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

